/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august september 1998.
 * This is total free software.
 *-------------------------------------
 * The sample moving. We are in moving mode, here are the handlers.
 */

#include "sample_moving.h"

#include "interface.h"
#include "xm.h"

/* didn't want to include, so... */
extern void around_sub_0(INTERFACE *, sample *, int);
extern void around_sub_1(INTERFACE *, sample *, int);

void nothing(INTERFACE *i, sample *samp)
{
  /* a dummy handler */
}

void right_1(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=3;
  around_sub_0(i, samp, IN);
}

void right_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=2;
  around_sub_0(i, samp, IN);
}

void right_4(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=5;
  around_sub_0(i, samp, IN);
}

void right_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=6;
  around_sub_0(i, samp, IN);
}

void right_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=7;
  around_sub_0(i, samp, IN);
}

void right_0_0(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=9;
  around_sub_0(i, samp, IN);
}

void right_0_1(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=10;
  around_sub_0(i, samp, IN);
}

void right_0_2(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=11;
  around_sub_0(i, samp, IN);
}

void right_0_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->right_0_3;
  around_sub_0(i, samp, IN);
}

void right_0_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=14;
  around_sub_0(i, samp, IN);
}

void right_0_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=15;
  around_sub_0(i, samp, IN);
}

void right_1_0(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=9;
  around_sub_1(i, samp, IN);
}

void right_1_1(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=samp->right_1_1;
  around_sub_1(i, samp, IN);
}

void right_1_2(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=12;
  samp->left_1_4=10;
  around_sub_1(i, samp, IN);
}

void right_1_3(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=12;
  samp->left_1_4=11;
  around_sub_1(i, samp, IN);
}

void (*right_handle[3][16])(INTERFACE *, sample *)={
  {nothing, right_1, nothing, right_3, right_4, right_5, right_6, nothing,
   right_0_0, right_0_1, right_0_2, right_0_3, nothing, right_0_5, right_0_6, nothing},
  {nothing, right_1, nothing, right_3, right_4, right_5, right_6, nothing,
   right_1_0, right_1_1, right_1_2, right_1_3, nothing},
  {nothing, right_1, nothing, right_3, right_4, right_5, right_6, nothing}
};

void left_2(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=3;
  around_sub_0(i, samp, IN);
}

void left_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=1;
  around_sub_0(i, samp, IN);
}

void left_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=4;
  around_sub_0(i, samp, IN);
}

void left_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=5;
  around_sub_0(i, samp, IN);
}

void left_7(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=6;
  around_sub_0(i, samp, IN);
}

void left_0_1(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=8;
  around_sub_0(i, samp, IN);
}

void left_0_2(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=9;
  around_sub_0(i, samp, IN);
}

void left_0_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=10;
  around_sub_0(i, samp, IN);
}

void left_0_4(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=11;
  samp->right_0_3=12;
  around_sub_0(i, samp, IN);
}

void left_0_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=11;
  samp->right_0_3=13;
  around_sub_0(i, samp, IN);
}

void left_0_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=13;
  around_sub_0(i, samp, IN);
}

void left_0_7(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=14;
  around_sub_0(i, samp, IN);
}

void left_1_1(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=8;
  around_sub_1(i, samp, IN);
}

void left_1_2(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=9;
  samp->right_1_1=10;
  around_sub_1(i, samp, IN);
}

void left_1_3(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=9;
  samp->right_1_1=11;
  around_sub_1(i, samp, IN);
}

void left_1_4(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=samp->left_1_4;
  around_sub_1(i, samp, IN);
}

void (*left_handle[3][16])(INTERFACE *, sample *)={
  {nothing, nothing, left_2, left_3, nothing, left_5, left_6, left_7,
   nothing, left_0_1, left_0_2, left_0_3, left_0_4, left_0_5, left_0_6, left_0_7},
  {nothing, nothing, left_2, left_3, nothing, left_5, left_6, left_7,
   nothing, left_1_1, left_1_2, left_1_3, left_1_4},
  {nothing, nothing, left_2, left_3, nothing, left_5, left_6, left_7}
};

void down_0(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->down_0;
  around_sub_0(i, samp, IN);
}

void down_1(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=4;
  around_sub_0(i, samp, IN);
}

void down_2(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=7;
  around_sub_0(i, samp, IN);
}

void down_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->down_3;
  around_sub_0(i, samp, IN);
}

void down__0_4(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->down__0_4;
  around_sub_0(i, samp, IN);
}

void down__0_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->up_0_4=5;
  around_sub_0(i, samp, IN);
}

void down__0_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->up_0_4=6;
  around_sub_0(i, samp, IN);
}

void down__0_7(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->up_0_4=7;
  around_sub_0(i, samp, IN);
}

void down_0_4(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->down_0_4;
  around_sub_0(i, samp, IN);
}

void down__1_4(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=samp->down__1_4;
  around_sub_1(i, samp, IN);
}

void down__1_5(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=12;
  samp->up_1_4=5;
  around_sub_1(i, samp, IN);
}

void down__1_6(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=12;
  samp->up_1_4=6;
  around_sub_1(i, samp, IN);
}

void down__1_7(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=12;
  samp->up_1_4=7;
  around_sub_1(i, samp, IN);
}

void down_1_2(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=11;
  around_sub_1(i, samp, IN);
}

void (*down_handle[3][16])(INTERFACE *, sample *)={
  {down_0, down_1, down_2, down_3,
   down__0_4, down__0_5, down__0_6, down__0_7,
   nothing, nothing, nothing, nothing, down_0_4, nothing, nothing, nothing
  },
  {down_0, down_1, down_2, down_3,
   down__1_4, down__1_5, down__1_6, down__1_7,
   nothing, nothing, down_1_2, nothing, nothing
  },
  {down_0, down_1, down_2, down_3,
   nothing, nothing, nothing, nothing
  }
};

void up_1(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=0;
  samp->down_0=1;
  around_sub_1(i, samp, IN);
}

void up_2(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=0;
  samp->down_0=2;
  around_sub_1(i, samp, IN);
}

void up_3(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=0;
  samp->down_0=3;
  around_sub_1(i, samp, IN);
}

void up_4(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=3;
  samp->down_3=4;
  around_sub_1(i, samp, IN);
}

void up_5(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=3;
  samp->down_3=5;
  around_sub_1(i, samp, IN);
}

void up_6(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=3;
  samp->down_3=6;
  around_sub_1(i, samp, IN);
}

void up_7(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=3;
  samp->down_3=7;
  around_sub_1(i, samp, IN);
}

void up_0_0(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=4;
  samp->down__0_4=8;
  around_sub_0(i, samp, IN);
}

void up_0_1(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=4;
  samp->down__0_4=9;
  around_sub_0(i, samp, IN);
}

void up_0_2(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=4;
  samp->down__0_4=10;
  around_sub_0(i, samp, IN);
}

void up_0_3(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=5;
  around_sub_0(i, samp, IN);
}

void up_0_4(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=samp->up_0_4;
  around_sub_0(i, samp, IN);
}

void up_0_5(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->down_0_4=13;
  around_sub_0(i, samp, IN);
}

void up_0_6(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->down_0_4=14;
  around_sub_0(i, samp, IN);
}

void up_0_7(INTERFACE *i, sample *samp)
{
  around_sub_0(i, samp, OUT);
  samp->subwindow=12;
  samp->down_0_4=15;
  around_sub_0(i, samp, IN);
}

void up_1_0(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=4;
  samp->down__1_4=8;
  around_sub_1(i, samp, IN);
}

void up_1_1(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=4;
  samp->down__1_4=9;
  around_sub_1(i, samp, IN);
}

void up_1_2(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=4;
  around_sub_1(i, samp, IN);
}

void up_1_3(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=10;
  around_sub_1(i, samp, IN);
}

void up_1_4(INTERFACE *i, sample *samp)
{
  around_sub_1(i, samp, OUT);
  samp->subwindow=samp->up_1_4;
  around_sub_1(i, samp, IN);
}

void (*up_handle[3][16])(INTERFACE *, sample *)={
  {nothing, up_1, up_2, up_3, up_4, up_5, up_6, up_7,
   up_0_0, up_0_1, up_0_2, up_0_3, up_0_4, up_0_5, up_0_6, up_0_7},
  {nothing, up_1, up_2, up_3, up_4, up_5, up_6, up_7,
   up_1_0, up_1_1, up_1_2, up_1_3, up_1_4},
  {nothing, up_1, up_2, up_3, up_4, up_5, up_6, up_7},
};
