/*
 * This file is part of xsoundtrack - a sound tracker for Linux.
 * Sed - july august 1998.
 * This is total free software.
 *-------------------------------------
 */

#ifndef _SCREEN_H_
#define _SCREEN_H_

#include <X11/Xlib.h>

void init_colors(Display *);
void draw_plot(Display *, Window, GC, int, int, int, unsigned long);
void draw_line(Display *, Window, GC, int, int, int, int, unsigned long);
void draw_string (Display *, Window, GC, int, int, char *, Font, unsigned long);
void draw_3d_box(Display *, Window, GC, int, int, int, int, unsigned long, int);
void draw_box(Display *, Window, GC, int, int, int, int, unsigned long);
void draw_rectangle(Display *, Window, GC, int, int, int, int, int, unsigned long);
void draw_3d_box_around(Display *, Window, GC, int, int, int, int, unsigned long, int);
void draw_arrow(Display *, Window, GC, int, int, int, int);

#define BLACK		0
#define WHITE		1
#define LIGHTBLUE	3
#define GREY		6
#define BLUE		8
#define YELLOW		9
#define RED		10

#endif /* _SCREEN_H_ */
